--[[
	
	"Sprint" script by Gaiyos #18271
	
	Author: Adrian Gajos
	Version: 1.0
	Release: 16.05.2017
	
	
	GNU General Public License:
		
		freedom 0 - The freedom to run the program as you wish, for any purpose.
		freedom 1 - The freedom to study how the program works, and change it so it does your computing as you wish.
		freedom 2 - The freedom to redistribute copies so you can help your neighbor.
		freedom 3 - The freedom to distribute copies of your modified versions to others.

]]

sprint = {}

------------
-- CONFIG --
------------
sprint.normal_speed = -10
sprint.run_speed = 0 -- 0 is default for run in CS2D! No 10 or 15.

----------
-- INIT --
----------
sprint.offset_speed = 30 -- walk + shield is slowed down by ~30
sprint.last_item = 0
sprint.cooldown = 0
sprint.cooldown_time = 0
sprint.cooldown_time2 = 0
sprint.player_moving = false
sprint.sound_path = false

function sprint.onMove(id, x, y, walk)
    if player(id, "bot") then return end

    local speed = player(id, "speedmod")

    if walk == 0 then
        if speed ~= sprint.normal_speed then
            speedmod(id, sprint.normal_speed)
            strip(id, 41)
            setweapon(id, sprint.last_item)
        end

        sprint.cooldown_time = 5
    else
        if speed == sprint.normal_speed then
            sprint.last_item = player(id, "weapontype")

            speedmod(id, sprint.normal_speed + sprint.offset_speed)
            equip(id, 41)
            setweapon(id, 41)
        end

        local speed = player(id, "speedmod")
        if speed - sprint.offset_speed < sprint.run_speed and sprint.cooldown_time2 == 0 then
            speedmod(id, speed + 1)

            sprint.cooldown_time2 = 5
        elseif sprint.cooldown_time2 > 0 then
            sprint.cooldown_time2 = sprint.cooldown_time2 - 1
        end

        sprint.cooldown_time = 2
    end

    -- sounds --
    local tilex, tiley = player(id, "tilex"), player(id, "tiley")
    local tile_property = tile(tilex, tiley, "property")
    local tile_properties = {
        [10] = "pl_dirt";
        [11] = "pl_snow";
        [12] = "pl_step";
        [13] = "pl_tile";
        [14] = "pl_wade";
        [15] = "pl_metal";
        [16] = "pl_wood";
    }

    local sound_name = tile_properties[tile_property]
    if sound_name then
        sprint.sound_path = "new_walk/" .. sound_name .. math.random(1, 4) .. ".wav"
    end

    sprint.player_moving = true
end
addhook("move", "sprint.onMove", -5)

function sprint.onMs100()
    local x, y = player(1, "x"), player(1, "y")

    if sprint.sound_path and sprint.player_moving and sprint.cooldown == 0 then
        sv_soundpos(sprint.sound_path , x, y, 0)
        sprint.cooldown = sprint.cooldown_time

        sprint.sound_path = false
    elseif sprint.cooldown > 0 then
        sprint.cooldown = sprint.cooldown - 1
    end

    sprint.player_moving = false
end
addhook("ms100", "sprint.onMs100", -5)

-------------
-- WRAPPER --
-------------
function speedmod(id, speed)
    parse("speedmod " .. id .. " " .. speed)
end

function sv_soundpos(soundfile, x, y, pid)
    parse('sv_soundpos "' .. soundfile .. '" ' .. x .. ' ' .. y .. ' ' .. pid)
end

function equip(id, wpn)
    parse("equip " .. id .. " " .. wpn)
end

function setweapon(id, wpn)
    if wpn == 0 then return end
    parse("setweapon " .. id .. " " .. wpn)
end

function strip(id, wpn)
    parse("strip " .. id .. " " .. wpn)
end